// cycle.h

class cycle {
	public:
		int pc;
		string opcmd;
		int rd;
		int qd;
		bool ma;
		int addr;
		void set(int pci, int rdi, int qdi);
		void set_addr(int maddr);
		void show(FILE *out, int ncycle);
};

class IFID {
	public:
		bool active;
		bool color;
		bool halt;
		int instr;
		int pc;
		int op, opx;
		int rd, ra, rb;
		void set(int inst, int nextpc);
		void show(FILE *out);
		void bubble();
};


class IDEX {
	public:
		bool active;
		bool color;
		bool halt;
		int pc;
		int instr;
		int rd, ra, rb;
		int qa, qb;
		void show(FILE *out);
		void bubble();
		void set(IFID &old);
};

class EXWB {
	public:
		bool active;
		bool color;
		bool halt;
		int pc;
		int instr;
		bool ma;
		int maddr;
		int jump;
		int ra, rb, rd;
		int qa, qb, qd;
		void show(FILE *out);
		void showmem(FILE *out);
		void set(IDEX &old);
		void forward(IDEX &IDEX_old, EXWB &EXWB_old, FILE *out, int ncycle);
		int execute(FILE *out, IFID &IFID_new, IDEX &IDEX_new);
};

class WBXX {
	public:
		bool active;
		bool color;
		int pc;
		int instr;
		int rd;
		int qd;
		void show(FILE *out);
		void set(EXWB &old);
};

